/*
 * WinApp.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __WinApp_h__
#define __WinApp_h__
/***************************************************************
	Application class
***************************************************************/
#include <Application.h>

#include "decoder/ScenarioDecoderSystem.h"
#include "decoder/ScenarioDecoder.h"

//
namespace App{
	class CWinApp;
	class CMainFrame;
	class CWinView;
};
//
// CWinApp
class App::CWinApp : public BApplication {
public:
// 
	CWinApp(char *_lpFileLst);
	~CWinApp(void);
	
private:
	BMenuBar *CreateMenuBar( void );

	virtual void ReadyToRun( void );
	virtual void AboutRequested( void );
	static int32 RunSD(void *_lpInfo);
	
	char m_lpFileLst[256];
	ALSD::CScenarioDecoder	*m_lpSD;
	ALSD::CGraphicView		*m_lpView;
	thread_id m_ThreadID;
		
};

#endif
