/*
 * WinView.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __WinView_h__
#define __WinView_h__
/***********************************************************
	WinView class
***********************************************************/
#include <View.h>
#include "WinApp.h"

#include "decoder/ScenarioDecoderSystem.h"
#include "decoder/ScenarioDecoder.h"

//
// CWinView
class App::CWinView : public BView {
public:
	//
	CWinView( BRect frame, const char *name, 
				uint32 resizeMask, uint32 flags );
	~CWinView();
	
	void SetGrpView( ALSD::CGraphicView *_lpView ){
		m_lpView = _lpView;
	}
protected:
	//
private:
	//
	void Draw(BRect updateRect);
	void MouseDown(BPoint where);
	void MouseMoved(BPoint point, uint32 transit, const BMessage *message);

	ALSD::CGraphicView *m_lpView;
};

#endif
