/*
 * AliceCG.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __AliceCG_h__
#define __AliceCG_h__
/**********************************************************************
	scenario decoder system alice cgformat base class
**********************************************************************/
#include "ScenarioDecoderSystem.h"
//
namespace ALSD {
	class CAliceCG;
};
//
namespace ALSD_ALCG {
	struct stALCG_Palette {
		struct {
			unsigned char red;
			unsigned char green;
			unsigned char blue;
			unsigned char alpha; // reserve
		}entry[256];
	};
	// 
	struct stVSPHeader {
		int X;
		int Y;
		int Width;
		int Height;
		int Pb;
		int Pp;	// PalettePtr????
		int Dp; // DataPtr????
	};
	
	//
	struct stPMSHeader {
		int Version;
		int Size;
		int Bpp;
		int BppS;
		int Sf;	// ????
		int Bf;	// ????
		int X;
		int Y;
		int Width;
		int Height;
		int DataPtr;
		int AlphaPtr; // or PalettePtr
		int Cp;	// ColorPtr????
	};
	// 
	struct stCGSize {
		long x;
		long y;
		long Width;
		long Height;
	};
};
//
//
class ALSD::CAliceCG {
public:
	CAliceCG(){};
	virtual ~CAliceCG(){};
	
	//
	virtual void GetCGSizeInfo( ALSD_ALCG::stCGSize *_lpCGSize ) = 0;
	virtual void DrawBitmap( ALSD::COffScreen &_Screen, long _x, long _y,
							 long _PosFlag, stGrpRect *_lpRect,
							 long _Brightness){};
	virtual void SetSpriteColor( long _SpriteColor ){};
protected:
private:
};

#endif