/*
 * AliceCG_PMS.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __AliceCG_PMS_h__
#define __AliceCG_PMS_h__
/**********************************************************************
	scenairo decoder system PMS base class
**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include "AliceCG.h"
//
namespace ALSD_ALCG {
	class CAliceCG_PMS;
};
//
// class
class ALSD_ALCG::CAliceCG_PMS : public ALSD::CAliceCG {
public:
	CAliceCG_PMS( const unsigned char *_lpMem ){ 
		m_lpShadowPMS = NULL;
		m_lpMem = _lpMem;
		m_SpColor = -1;
	};
	virtual ~CAliceCG_PMS(){};

	virtual void GetCGSizeInfo( stCGSize *_lpCGSize );
	virtual void SetSpriteColor( long _SpriteColor ){ m_SpColor = _SpriteColor;};

	//
	void ExpandPal( ALSD_ALCG::stALCG_Palette *_lpPal );
	void Expand64K( unsigned short *_lpPic, unsigned char *_lpAlpha );
	void Expand256( unsigned char *_lpPic, long _Ptr);

	void SetShadow( CAliceCG_PMS *_lpShadow ){ m_lpShadowPMS = _lpShadow;};

protected:
	//
	void GetHeader( void );
	void GetPalette(void );	
	//
	long m_SpColor;	// XvCgFiCfbNX)
	//
	const unsigned char	*m_lpMem;
	//
	ALSD_ALCG::stPMSHeader		 m_Header;
	ALSD_ALCG::stALCG_Palette	 m_Palette;

	ALSD_ALCG::CAliceCG_PMS		*m_lpShadowPMS;

private:
};

#endif
