/*
 * FileAld.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __FileAld_h__
#define __FileAld_h__
/**********************************************************************
	.ALD file class

**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include <string>

//
namespace ALSD{
	class CFileAld;
	typedef std::vector< ALSD::CFileData * > FileDataVec;
};
//
class CFilePtr;
//
// class
class ALSD::CFileAld {
public:
	// RXgNV
	CFileAld();
	virtual ~CFileAld();
	
	//
	HRESULT	Open( const char *_lpFileName, FILEDATATYPE _type, long _FileNo );
	HRESULT Close( void );
	HRESULT Destroy(void);

	
	HRESULT GetSize( long &_size ); 
	HRESULT Load( CFileData *_lpData, long _Num);
	// LbVt
	HRESULT Load( CFileData **_lplpData, long _Num);
protected:
	//
	long			 m_MapSize;
	unsigned char	*m_lpFileMap;	// file map
	unsigned char	*m_lpFilePtr;	// file pointer
	long			 m_FileNo;		// my file no
	
	//
	std::string		 m_strFileName; // t@C
	FILEDATATYPE	 m_Type;		// t@C
	FileDataVec		 m_vcFileData;

private:
};

#endif
