/*
 * GraphicDriver_BeOS.h
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */
#ifndef __GraphicDriver_BeOS_h__
#define __GraphicDriver_BeOS_h__
/**********************************************************************
	scenario decoder system BeOS
**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include "GraphicDriver.h"

namespace ALSD_BeOS {
	class CGraphicDriver_BeOS;
	class COffScreen_BeOS;
};

namespace App{
	class CMainFrame;
};

//
// class
class ALSD_BeOS::CGraphicDriver_BeOS : public ALSD::CGraphicDriver {
public:
	CGraphicDriver_BeOS( ALSD::CScenarioDecoder *_lpScenarioDecoder );
	virtual ~CGraphicDriver_BeOS();

	// system function(ms)
	virtual void Sleep( unsigned long Milliseconds );
	virtual void GetTickCount( unsigned long *_Milliseconds );
	virtual void GetSystemName( std::string &_str ){_str = "BeOS R4";};
	virtual void PumpMessage( void );

	// interface implement
	virtual void OnDraw( stGrpRect *_lpUpdateRect );
	virtual void SetLocalInfo( void *_lpInfo );
	virtual void SetViewSize( long _start_x, long _start_y, long _size_x, long _size_y );
	virtual void SetWindowTitle( const char *_lpTitle );
	virtual void SetMousePos( long _x, long _y );
protected:
//	BView *m_lpView;
	App::CMainFrame *m_lpMainFrame;
private:
};

#endif
