/*
 * GraphicView.h - "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __GraphicView_h__
#define __GraphicView_h__
/**********************************************************************
	CGraphicView common interface
**********************************************************************/
#include "ScenarioDecoderSystem.h"
//
namespace ALSD {
	class CGraphicView;
};

//
struct stGrpRect {
	long left, top, right, bottom;
};
struct stGrpPoint {
	long x, y;
};

//
//
class ALSD::CGraphicView{
public:
	CGraphicView(){};
	virtual ~CGraphicView(){};

	// interface
	virtual void SetLocalInfo( void *lpInfo ) = 0;
	
	virtual void OnDraw( stGrpRect *_lpUpdateRect ) = 0;
	virtual void OnLButtonDown	( stGrpPoint *_lpPoint ) = 0;
	virtual void OnLButtonUp	( stGrpPoint *_lpPoint ) = 0;
	virtual void OnRButtonDown	( stGrpPoint *_lpPoint ) = 0;
	virtual void OnRButtonUp	( stGrpPoint *_lpPoint ) = 0;
	virtual void OnMouseMove	( stGrpPoint *_lpPoint ) = 0;
	virtual void OnKeyDown		( unsigned int _KeyCode )= 0;
	virtual void OnKeyUp		( unsigned int _KeyCode )= 0;

protected:
private:
};

#endif

