/*
 * OffScreen_BeOS.h
 *		- "ALICE SOFT System3.x" compatible scenario decoder SD35
 *
 * Copyright (C) 1999 Atsushi Mizuguchi  All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * 
 */

#ifndef __OffScreen_BeOS_h__
#define __OffScreen_BeOS_h__
/**********************************************************************
	scenario decoder system offscreen for BeOS
**********************************************************************/
#include "ScenarioDecoderSystem.h"
#include "OffScreen.h"
#include <Bitmap.h>
#include <Font.h>

namespace ALSD_BeOS {
	class COffScreen_BeOS;
};

//
//
class ALSD_BeOS::COffScreen_BeOS : public ALSD::COffScreen {
public:
	COffScreen_BeOS();
	virtual ~COffScreen_BeOS();
	
	// interface implement
	virtual void Create( long _w, long _h, long _bpp );
	virtual void Destroy(void );
	virtual void CreateView( long _w, long _h );
	virtual void DestroyView( void );
	virtual void UpdateView( stGrpRect *_lpRect, void *_lpInfo );

	virtual bool Lock( 	ALSD_OFFSCR::stGrpScreenBits *_lpBits,
						ALSD_OFFSCR::stGrpScreenDesc *_lpDesc );
	virtual bool Unlock(void);

	virtual void FillRect	( long _x, long _y, long _w, long _h, unsigned long _rgb32 );
	virtual void StrokeRect	( long _x, long _y, long _w, long _h, unsigned long _rgb32 );
	virtual void StrokeLine	( long _x1,long _y1,long _x2,long _y2,unsigned long _rgb32 );
	virtual void SetFontSize( long _size );
	virtual long GetFontSize( void ){ return m_FontSize;};
	virtual void SetFont	( long _num ){};
	virtual void DrawString	( long _x, long _y, const char *_lpString, unsigned long _rgb32 );

protected:
	//
	void			*m_lpBits;		// bits
	BBitmap			*m_lpBitmap;	// bitmap
	BView			*m_lpView;		// view
	unsigned char	*m_lpAPtr;		// alpha pointer
	void			*m_lpAlphaBits;	// alpha plane
	
	// backups
	void			*m_lpAlphaBackup;
	unsigned char	*m_lpABackupPtr;
	void			*m_lpColorBackup;
	unsigned long	*m_lpCBackupPtr;
	
	//
	bool MyLock(void);
	bool MyUnlock(void);

	//
	long 			 m_FontSize;
	BFont			*m_lpFont;
private:

};

#endif
